/* SF The Oort Cloud v1.3 r070716 */

/* Global variables */
var SFStart = new Date(), SFAbbreviated = location.pathname.lastIndexOf('NEW') > 0;
var SFIsTiger = navigator.appVersion.indexOf('AppleWebKit/312') < 0, SFR = 'sevenfour://skin/SFR/';
var SFISCache, SFSSImgs, SFSelectedText, SFSecondRes, SFThreadURI, SFThreadHasID, SFNextRes = 0;
var SFMessageClear, SFRemoveBezel, SFScrolling;

/* Essential */
var sevenfour = {
    appendNewRes : function(new_res) {
        SFStart = new Date();
        var e = document.createElement('dl'), dls = document.getElementsByTagName('dl');
        if (dls[0].style.display == 'none') sfg.GalleryMode();
        sf.id('new').removeAttribute('id'); e.id = 'new'; e.innerHTML = new_res;
        document.body.insertBefore(e,dls[dls.length-1].nextSibling);
        sfevt.recount(e);
    },
    scrollToNew : function() {
        scrollTo(0,sf.id('new').offsetTop-16);
    },
    scrollToMessage : function(str) {
        var dts = document.getElementsByTagName('dt'), l = dts.length;
        var e = /b/i.test(str) ? sf.id('bookmark').parentNode :
                /n/i.test(str) ? sf.id('new') :
                /t/i.test(str) ? sf.id('sfheader') :
                /g/i.test(str) ? sf.id('sfgallery') :
                /l([0-9]{1,3})/i.test(str) ? dts[l-1-parseInt(RegExp.$1)].parentNode :
                /l/i.test(str) ? sf.latestRes() : sf.id(str);
        e.style.display != 'none' ? scrollTo(0,e.offsetTop-16) : this.scrollToNew();
    },
    countOfID : function(key) {
        return sevenfour.countOfIDs[key];
    }
};

/* SF Main events */
var sfevt = {
    onLoad : function(dts,l) {
        var sign = document.createElement('div'), new_dl = sf.id('new'), new_res = new_dl.firstChild;
        sign.id = 'sfnewressign'; sign.innerHTML = 'New Res&thinsp;<span>∷</span>&thinsp;<span>'+new_dl.childNodes.length+'</span>';
        sign.style.display = new_res ? 'block' : 'none'; new_dl.insertBefore(sign,new_res);
        if (! new_res || sign.nextSibling.id != '1') sevenfour.scrollToNew();
        var lr = parseInt(dts[l-1].parentNode.id), bl = sf.id('parentdirectory'), lf = sf.id('loadfactor'), pd = location.pathname.match(/.read.cgi.([0-9a-z]+)/i)[1];
        SFSecondRes = l < lr ? dts[1].parentNode.id : 1;
        if (SFAbbreviated) {
            if (l < lr) {lf.innerText = 'All';}
            else {lf.style.display = 'none'; lf.parentNode.item(3).nodeValue = '';}
        } else {lf.innerText = 'Min';}
        if (pd == 'mac' || pd == 'jobs') bl.className = 'mac'; bl.innerText = pd;
        bl.href = bl.title = 'http://'+location.hostname+'/'+pd+'/';
        sf.id('information').title = document.title; sf.id('count').innerText = l;
        sf.id('range').innerText = lr > 1 ? SFSecondRes+'-'+lr : 1;
        sf.gradationString(sf.id('sfheader').item(0),44,44,44,192); this.checkTheReferrer(lr);
        sf.loadTimer(); sf.changeTheAppearance(); SFSelectedText = getSelection();
        SFThreadURI = sf.id('sfheader').item(0).href; SFThreadHasID = sf.element(dts[0],'id') != undefined;
        delete this.onLoad;
    },
    onPopup : function(first_res,l) {
        var e = document.body; e.className = 'popup';
        if (l > 1) {
            var count = document.createElement('div'), same_id = 1; 
            e.className += ' multiplex'; count.id = 'sfpopupheader';
            if (sf.element(first_res,'id')) {
                var es = document.getElementsByTagName('coid'), ID = es[0].cid;
                for (var i = 1; i < l; i++) {
                    var id = es[i].cid; if (id.indexOf('?') != 0 && id == ID) same_id++; else break;
                }
            }
            count.innerText = same_id == l ? 'ID: '+ID+' ∷ '+l+' Res' : l+' Res';
            e.insertBefore(count,e.firstChild);
        }
    },
    recount : function(new_dl) {
        var es = new_dl.getElementsByTagName('coid'), l = es.length;
        var first = new_dl.firstChild, sign = sf.id('sfnewressign');
        sign.parentNode.removeChild(sign); sign.style.display = 'block';
        sign.lastChild.innerText = l; first.parentNode.insertBefore(sign,first);
        sevenfour.scrollToNew();
        var lr = parseInt(new_dl.lastChild.id);
        sf.id('count').innerText = document.getElementsByTagName('dt').length;
        sf.id('range').innerText = SFSecondRes+'-'+lr;
        if (SFThreadHasID) {
            var IDArray = [], Checked = [], i; if (lr > 1000) l -= 1;
            for (i = 0; i < l; i++) {
                var id = es[i].cid; IDArray[i] = id.indexOf('?') != 0 ? id : 'unidentified';
            }
            var IDs = IDArray.toString().replace(/,+/,'');
            for (i = 0; i < l; i++) {
                var id = IDArray[i];
                if (Checked[id]) {
                } else {
                    var str = id.replace(/[^0-9a-z]/ig,'.'), dID = new RegExp(',?'+str,'g');
                    if (id != 'unidentified') {
                        var ID = new RegExp(',?'+str+',?','g'), coid = sevenfour.countOfIDs[id];
                        var new_count = IDs.match(ID).length;
                        sevenfour.countOfIDs[id] = coid ? coid+new_count : new_count;
                    } else {
                        sevenfour.countOfIDs[id] = '?';
                    }
                    IDs = IDs.replace(dID,''); Checked[id] = 'settled';
                }
            }
            for (i = 0; i < l; i++) {
                var c = sevenfour.countOfIDs[IDArray[i]];
                es[i].innerText = c; es[i].className = c != '?' ? 'c'+c : 'c0';
            }
            delete IDArray; delete Checked;
        }
        this.checkTheReferrer(lr); sf.loadTimer();
        if (sf.id('rangechanger')) sf.rangeChanger(true);
    },
    checkTheReferrer : function(latest) {
        var rs =[], referred = [],  dds = document.getElementsByTagName('dd'), ddsl = dds.length;
        var res_anchor = /^>>?([1-9][0-9]{0,3})([,-]?)([1-9][0-9]{0,3})?/, number = /([1-9][0-9]{0,3})/g;
        var cache = function(rn,referrer) {
            if (sf.id(rn)) {
                if (! rs[rn]) {rs[rn] = []; referred[referred.length] = rn;}
                if (rs[rn][rs[rn].length-1] != referrer) rs[rn][rs[rn].length] = referrer;
            }
        };
        for (var i = SFNextRes; i < ddsl; i++) {
            var as = dds[i].getElementsByTagName('a'), asl = as.length;
            if (! as) {
            } else {
                for (var j = 0; j < asl; j++) {
                    var str = as[j].innerText;
                    if (str.indexOf('>') != 0) {
                    } else {
                        var ra = str.match(res_anchor);
                        if (! ra) {
                        } else {
                            var re = as[j].parentNode.parentNode.id;
                            if (! ra[2]) {
                                cache(ra[1],re);
                            } else if (ra[2] == ',') {
                                var csv = str.match(number), csvl = csv.length;
                                for (var k = 0; k < csvl; k++) cache(csv[k],re);
                            } else if (ra[2] == '-' && ra[3] <= latest) {
                                var first = parseInt(ra[1]), last = parseInt(ra[3]);
                                if (first <= last) for (var m = first; m <= last; m++) cache(m,re);
                            }
                        }
                    }
                }
            }
        }
        for (var i = 0, l = referred.length; i < l; i++) {
            var e = sf.element(referred[i],'cor'), res = rs[referred[i]], nc = res.length;
            var c = parseInt(e.parentNode.className.substr(1));
            e.parentNode.className = c ? 'c'+(c+nc) : 'c'+nc;
            if (! c) e.href = '#'+res; else e.href += ','+res;
        }
        SFNextRes = ddsl; delete rs; delete referred;
    },
    extractionSequence : function(dd) {
        if (dd.className == 'settled') return; else dd.className = 'settled';
        var idre = new RegExp('ID: ?[a-z0-9\+\/]{5,}','ig'), hasAnchor = dd.getElementsByTagName('a').length > 0;
        if (idre.test(dd.innerText)) {
            var ids = dd.innerText.match(idre), l = ids.length, label = /ID: ?/i, ct = '</a>';
            for (var i = 0; i < l; i++) {
                var ot = '<a href="sevenfour://internal/popup'+ids[i].replace(label,'#')+'">';
                dd.innerHTML = dd.innerHTML.split(ids[i]).join(ot+ids[i]+ct);
            }
        }
        dd = sf.id(dd.parentNode.id).getElementsByTagName('dd')[0];
        if (hasAnchor && sfv.arrangement(dd)) sfg.sequentialExtraction(dd,0);
    }
};

/* Various search */
var sfi = {
    currentMode : function() {
        var es = document.isearch.elements, l = es.length, i;
        for (i = 0; i <= l; i++) if (es[i].checked) return es[i].id;
    },
    regexp : function(func,str) {
        var RE = str+'';
        if (! document.isearch.remode.checked) RE = RE.replace(/([^a-z0-9_])/ig,'\\$1');
        switch (func) {
            case 'search': RE = new RegExp('.?'+RE,'i'); break;
            case 'highlight': RE = new RegExp('.?('+RE+')','i'); break;
        }
        return RE;
    },
    cache : function() {
        SFISCache = []; SFISCache['message'] = []; SFISCache['name'] = [];
        var dds = document.getElementsByTagName('dd'), ns = document.getElementsByTagName('name');
        for (var i = 0, l = dds.length; i < l; i++) {
            SFISCache['message'][i] = dds[i].innerText.replace(/\n/g,''); SFISCache['name'][i] = ns[i].innerText;
        }
    },
    selectCache: function() {
        switch (this.currentMode()) {
            case 'rsmode': return SFISCache['message']; break;
            case 'nsmode': return SFISCache['name']; break;
            case 'msmode': return SFISCache['mail']; break;
            case 'dsmode': return SFISCache['date']; break;
            case 'idsmode': return SFISCache['id']; break;
        }
    },
    iSearch : function(isquery) {
        switch (this.currentMode()) {
            case 'wsmode': return;
            case 'cormode': this.restrictor('cor',isquery); return;
            case 'coidmode': this.restrictor('coid',isquery); return;
            default: if (! isquery) {this.reset(); return;}
                if (sf.id('rfmode').checked || sf.id('type').innerText == 'URI') return;
        }
        var st = new Date(), c = this.selectCache(), count = 0;
        var dts = document.getElementsByTagName('dt'), l = dts.length;
        isquery = this.regexp('search',isquery);
        if (! document.isearch.pumode.checked) {
            for (var i = 0; i < l; i++) {
                if (! isquery.test(c[i]) || dts[i].parentNode.className.indexOf('residue') != -1) {
                    dts[i].parentNode.style.display = 'none';
                } else {
                    dts[i].parentNode.style.display = 'block'; count++;
                }
            }
            this.rewind(count);
        } else {
            for (var j = 0, resIDs = []; j < l; j++) {
                if (! isquery.test(c[j]) || dts[j].parentNode.className.indexOf('residue') != -1) {}
                else {resIDs[resIDs.length] = dts[j].parentNode.id; count++;}
            }
            sf.id('resultanchor').href = count > 0 ? '#'+resIDs : 'javascript:void(0)';
            sf.id('resultanchor').innerText = count;
            delete resIDs;
        }
        sf.displayTheResult(count,'iSearch',sf.loadTimer(st));
    },
    rewind : function(count_result,first_match,offset) {
        var new_sign = sf.id('sfnewressign');
        if (count_result == document.getElementsByTagName('dt').length) {
            if (new_sign.nextSibling) new_sign.style.display = 'block';
            if (first_match) scrollTo(0,first_match.offsetTop-offset);
            else sevenfour.scrollToNew();
        } else {
            new_sign.style.display = 'none';
            scrollTo(0,0);
        }
    },
    restrictor : function(require) {
        var act = sf.id('sfrestrictor').className;
        var es = document.getElementsByTagName(act), dts = document.getElementsByTagName('dt');
        for (var i = 0, l = es.length, count = 0; i < l; i++) {
            var cox = parseInt(es[i].className.substr(1));
            if (act == 'coid' && require == 1) {
                if (! cox || cox != 1) {dts[i].parentNode.style.display = 'none';}
                else {dts[i].parentNode.style.display = 'block'; count++;}
            } else {
                if (! cox || cox < require) {dts[i].parentNode.style.display = 'none';}
                else {dts[i].parentNode.style.display = 'block'; count++;}
            }
        }
        this.rewind(count);
        sf.statusMessage((act=='cor'?require+' or more replies ∷ ':require==1?'Single ID ∷ ':require+' or more messages ∷ ')+count);
    },
    reset : function(highlight) {
        sf.statusMessage('');
        var dds = document.getElementsByTagName('dd'), l = dds.length, none = 0, i;
        for (i = 0; i < l; i++)
            if (dds[i].parentNode.style.display != 'none') {
                var firstMatch = dds[i].parentNode, offset = firstMatch.offsetTop; break;
            }
        for (i = 0; i < l; i++) {
            var e = dds[i].parentNode;
            if (e.style.display != 'none') {}
            else if (e.className.indexOf('residue') == -1) {e.style.display = 'block'; none++;}
        }
        if (none > 0) this.rewind(l,none == l ? false : firstMatch,offset);
        if (highlight && document.getElementsByTagName('strong').length > 0) {
            var st = new RegExp('<\/?STRONG>','ig');
            for (i = 0; i < l; i++)
                if (dds[i].getElementsByTagName('strong').length > 0)
                    dds[i].innerHTML = dds[i].innerHTML.replace(st,'');
        }
        if (document.isearch.pumode.checked) {
            sf.id('resultanchor').href = 'javascript:void(0)'; sf.id('resultanchor').innerText = '0';
        }
        if (SFISCache) this.cache();
    },
    action : function() {
        var isf = document.isearch.query;
        if (sf.id('type').innerText == 'URI') {
            isf.value.indexOf('/test/read.cgi/') > 0 ?
                location.href = isf.value + '/NEW' : isf.value = '';
            isf.blur();
        } else if (document.isearch.wsmode.checked) {            
            this.webSearch('Google');
        } else if (document.isearch.rfmode.checked && isf.value != '') {
            var dts = document.getElementsByTagName('dt'), l = dts.length, count = 0;
            var keyword = this.regexp('search',isf.value), c = this.selectCache();
            for (var i = 0; i < l; i++) {
                if (! keyword.test(c[i])) {
                } else {
                    if (! sfSystem.filter(dts[i].parentNode.id))
                        sfSystem.setFilter(dts[i].parentNode.id,true,true);
                    count++;
                }
            }
            this.reset(); sf.displayTheResult(count,'zap');
        }
    },
    highlight : function(str) {
        if (! SFISCache) return;
        var query = document.isearch.query.value;
        var keyword = str != '' ? str : query != '' ? query : prompt('キーワード','');
        if (keyword && keyword != ' ') {
            var st = new Date(), ot = '<strong>', ct = '</strong>', count = 0;
            var dds = document.getElementsByTagName('dd'), l = dds.length;
            keyword = this.regexp('highlight',keyword);
            for (var i = 0; i < l; i++) {
                var match = SFISCache['message'][i].match(keyword);
                if (! match || dds[i].parentNode.className.indexOf('residue') != -1) {
                } else {
                    dds[i].innerHTML = dds[i].innerHTML.split(match[1]).join(ot+match[1]+ct);
                    count++;
                }
            }
        }
        sf.displayTheResult(count,'hl',sf.loadTimer(st));
    },
    webSearch : function(search_engine,str) {
        var fstr = document.isearch.query.value, URI, ps;
        switch (search_engine) {
            case 'Google': ps = 'Google 検索';
                URI = 'http://www.google.com/search?hl=ja&q='; break;
            case 'SearchMash': ps = 'SearchMash 検索';
                URI = 'http://www.searchmash.com/search/'; break;
            case 'Clusty': ps = 'Clusty 検索';
                URI = 'http://clusty.com/search?input-form=clusty-simple&v:sources=webplus&query='; break;
            case 'Translate': ps = 'Google 英日翻訳';
                URI = 'http://translate.google.com/translate_t?langpair=en|ja&hl=ja&ie=UTF8&text='; break;
            case 'Wikipedia': ps = 'Wikipedia 検索';
                URI = 'http://ja.wikipedia.org/w/wiki.phtml?search='; break;
            case 'iTS': ps = 'iTunes Store 検索';
                URI = 'itms://phobos.apple.com/WebObjects/MZSearch.woa/wa/search?term='; break;
            case 'Google:2ch.net': ps = 'Google で 2ch.net 内を検索';
                URI = 'http://www.google.com/search?hl=ja&q=site:2ch.net+'; break;
        }
        var query = SFSelectedText != '' ? SFSelectedText : fstr != '' && SFISCache ? fstr : prompt((ps),'');
        if (query) location.replace(encodeURI(URI+query));
    },
    setValue : function(str) {
        if (SFISCache) {
            var isf = document.isearch.query;
            isf.value = str; setTimeout('document.isearch.query.focus()',50);
            isf.setSelectionRange(isf.value.length,isf.value.length);
        }
    },
    quick : function(func,str) {
        if (str != '') this.setValue(str);
        switch (func) {
            case 'search': this.iSearch(str != '' ? str : document.isearch.query.value); break;
            case 'highlight': this.highlight(str != '' ? str : ''); break;
        }
    },
    fade : function() {
        var iss = sf.id('isearch').style, tts = sf.id('sfheader').style, btn = sf.id('isbtn');
        var height = iss.opacity <= 0 ? 0 : 28, posY = iss.opacity <= 0 ? 24 : 17;
        if (iss.opacity <= 0) {
            var opa = 0; iss.display = 'block'; tts.visibility = 'hidden';
            var fadein = setInterval(function() {
                if (iss.opacity < 1) {
                    iss.height = (height += 7) +'px';
                    iss.top = (posY -= 2) +'px';
                    iss.opacity = (opa += 0.3);
                } else {
                    clearInterval(fadein);
                    sfi.cache();
                    btn.src = SFR+'magnifyingGlassActive.png';
                }
            },20);
        } else {
            var fadeout = setInterval(function() {
                if (iss.opacity > 0) {
                    iss.opacity -= 0.3;
                    iss.top = (posY -= 1) +'px';
                    iss.height = (height -= 7) +'px';
                } else {
                    clearInterval(fadeout);
                    sfi.reset();
                    sf.id('sfheader').style.visibility = 'visible';
                    if (sf.id('remode').checked) sfi.modeChange('remode');
                    if (sf.id('rfmode').checked) sfi.modeChange('rfmode',null,true);
                    document.isearch.query.blur(); iss.display = 'none';
                    SFISCache = null; delete SFISCache;
                }
            },20);
        }
    },
    modeChange : function(mode,pumode,rfmode) {
        var changeColor = function() {
            var not_is = sf.id('wsmode').checked || sf.id('type').innerText == 'URI';
            sf.id('query').style.color = not_is ? 'black' : sf.id('rfmode').checked ? 'red' : sf.id('remode').checked ? '#1a1' : sf.id('pumode').checked ? '#12d' : 'black';
        };
        var transform = function(form_w,opt_s,ph) {
            var isf = document.isearch.query;
            sf.id('isearchicon').src = SFR+(mode != 'wsmode' ? 'sevenfour' : 'globe')+'.png';
            sf.id('type').innerText = mode != 'urimode' ? 'Search' : 'URI';
            sf.id('modecycler').src = SFR+mode+'.png';
            sf.id('modecycler').style.display = mode != 'urimode' ? 'inline' : 'none';
            sf.id('searchoption').style.display = sf.id('hlbtns').style.display = opt_s;
            sf.id('wsbtns').style.display = mode == 'wsmode' ? 'inline' : 'none';
            isf.style.width = form_w+'em'; isf.setAttribute('placeholder',ph);
            if (mode != 'urimode') {
                isf.type = 'search'; isf.setAttribute('results',15); sf.id(mode).checked = true;
            } else {
                isf.type = 'text'; isf.removeAttribute('results');
            }
            changeColor();
        };
        var toggleOption = function(opt) {
            if (! SFISCache || sf.id('wsmode').checked || sf.id('type').innerText == 'URI') return;
            var act = 'url(sevenfour://skin/SFR/activeRing.png) no-repeat center';
            if (opt == 'regexpsw') {
                sf.id(mode).checked = sf.id(mode).checked ? false : true;
                sf.id(opt).src = SFR+(sf.id(mode).checked ? mode : mode+'Inactive')+'.png';
                sf.id(opt).style.background = sf.id(mode).checked ? act : 'none';
            } else {
                if (opt == 'resultpopup' || ! pumode && ! rfmode) {
                    if (opt == 'resultpopup') sf.id('rfmode').checked = false;
                    sf.id('pumode').checked = true;
                    sf.id('optioncycler').src = SFR+'puMode.png';
                    sf.id('optioncycler').style.background = act;
                    if (! sf.id('resultanchor')) {
                        var a = document.createElement('a'); a.id = 'resultanchor';
                        a.href = 'javascript:void(0)'; a.innerText = '0';
                        sf.id('searchoption').appendChild(a);
                    }
                } else if (pumode) {
                    sf.id('pumode').checked = false; sf.id('rfmode').checked = true;
                    sf.id('optioncycler').src = SFR+'rfMode.png';
                    sf.id('searchoption').removeChild(sf.id('resultanchor'));
                } else {
                    sf.id('rfmode').checked = false;
                    sf.id('optioncycler').src = SFR+'optModeInactive.png';
                    sf.id('optioncycler').style.background = 'none';
                }
            }
            changeColor();
        };
        switch (mode) {
            case 'rsmode': transform(17,'inline','レス'); break;
            case 'nsmode': transform(17,'inline','名前'); break;
            case 'wsmode': transform(20,'none','ウェブ'); break;
            case 'remode': toggleOption('regexpsw'); break;
            case 'pumode': toggleOption('resultpopup'); break;
            case 'rfmode': toggleOption(); break;
            case 'cycleopt': toggleOption(); break;
            default:
                if (sf.id('type').innerText != 'URI' && SFISCache) transform(28,'none','スレッド URI');
                else if (SFISCache) sf.id('rsmode').checked ? sfi.modeChange('rsmode') :
                    sf.id('nsmode').checked ? sfi.modeChange('nsmode') : sfi.modeChange('wsmode');
        }
    }
};

/* Video relation */
var sfv = {
    arrangement : function(dd) {
        var as = dd.getElementsByTagName('a'), l = as.length;
        var yt = new RegExp('http:\/\/(www|jp)\.youtube\.com\/watch.v=([^&]+)','i');
        var gv = new RegExp('http:\/\/video\.google\.com\/videoplay.docid=([^&]+)','i');
        for (var i = 0; i < l; i++) {
            var URI = as[i].href, ytid = URI.match(yt), gvid = URI.match(gv);
            if (ytid || gvid) {
                var div = document.createElement('div'); div.className = 'vunit';
                div.innerHTML = '<a href="'+URI+'">'+as[i].innerText+'</a> <img class="togglevideo" src="'+SFR+'loadVideo.png" onclick="sfv.switchover(this,\''+(ytid ? ytid[2] : gvid[1])+'\',\''+(ytid ? 'YT' : 'GV')+'\');" ondragstart="return false;" alt="Load/Remove video" />';
                as[i].parentNode.replaceChild(div,as[i]);
            }
        }
        return true;
    },
    switchover : function(btn,vid,vtype) {
        var unit = btn.parentNode;
        if (unit.firstChild.nodeName != 'BLOCKQUOTE') {
            var vc = document.createElement('blockquote'); vc.className = 'moviecontainer';
            var p = document.createElement('p'), obj = document.createElement('object');
            var vsrc = vtype == 'YT' ? 'http://www.youtube.com/v/'+vid : 'http://video.google.com/googleplayer.swf?docId='+vid+'&hl=en';
            with (obj) {
                type = 'application/x-shockwave-flash'; data = vsrc;
                //type = 'video/x-flv'; data = vsrc;
                width = vtype == 'YT' ? '425' : '400'; height = vtype == 'YT' ? '350' : '326';
                innerHTML = '<param name="movie" value="'+vsrc+'" />';
            }
            p.appendChild(obj); vc.appendChild(p); unit.insertBefore(vc,unit.firstChild);
            btn.src = SFR+'remove.png';
            scrollTo(0,unit.firstChild.offsetTop-18);
        } else {
            var yo = pageYOffset-(unit.firstChild.offsetHeight+10);
            unit.removeChild(unit.firstChild);
            btn.src = SFR+'loadVideo.png';
            scrollTo(0,yo);
        }
    }
};

/* Image relation */
var sfg = {
    ICNextRes : 0, ICNextAnchor : 0, ICExecuting : false,
    imgSuffix : function(str) {
        return /^http:.{5,}(jpe?g|png|gif|tiff?|bmp)$/i.test(str);
    },
    load : function(element,URI,index,str,collect) {
        var ic = document.createElement('div');
        ic.className = ! collect ? 'imgcontainer' : this.GalleryImgLength()%2 != 0 ? 'imgcontainer right' : 'imgcontainer left';
        ic.innerHTML = '<img src="'+URI+'" class="loading" onload="sfg.loaded(this.parentNode,'+index+','+collect+');" onerror="sfg.loadFailed(this,'+index+','+collect+');" alt="&emsp;Failed to load&emsp;" /><br />';
        ic.innerHTML += collect ? '<a href="#'+str+'">'+str+'&thinsp;➠&thinsp;</a><span class="imgopener">'+URI+'</span>' : '<a href="'+URI+'"><img src="'+SFR+'imgPopuper.png" alt="Popup" /></a> <span class="imgopener">'+str+'</span>';
        if (collect) sf.id('sfgallery').appendChild(ic);
        else element.parentNode.replaceChild(ic,element);
    },
    loadSS : function(element,URI,index) {
        var ss = document.createElement('span'), br = document.createElement('br');
        ss.innerHTML = '<img src="http://mozshot.nemui.org/shot?'+URI+'" class="sitess" onload="sfg.sequentialExtraction(this.parentNode.parentNode,'+index+');" onclick="sfg.largeSS(\''+URI+'\');" width="128" height="128" alt="" />';
        element.parentNode.insertBefore(ss,element);
        element.parentNode.insertBefore(br,element.nextSibling);
    },
    largeSS : function(URI) {
        var html = '<a href="'+URI+'"><img src="http://mozshot.nemui.org/shot/256x256?'+URI+'" width="256" height="256" alt="" /></a>';
        sfSystem.popupWindow(html,272,272);
    },
    loaded : function(img_parent,index,collect) {
        var img = img_parent.firstChild, pe = img_parent.parentNode; img.className = 'thumbnail';
        var e = document.createElement('img'); e.className = 'imgtoggle'; e.src = SFR+'hideImg.png';
        Reflection.add(img,{height: 0.2, opacity: 0.8});
        if (pe.nodeName == 'DD') {
            this.centeringBtn(e,img);
            if (sf.id('sfinfobar') && ! sf.id('slideshowstart')) {
                var ss = document.createElement('li'); ss.id = 'slideshowstart';
                ss.innerHTML = '<img src="'+SFR+'slideShowBtn.png" onclick="sfg.slideShow(\'Res\');" alt="SS" />';
                sf.id('complex').insertBefore(ss,sf.id('loadtime'));
            }
        }
        img_parent.insertBefore(e,img_parent.firstChild.nextSibling); setTimeout('sf.correctRendering()',25);
        if (collect) {
            this.counterUpdate(true); if (this.ICExecuting) this.sequentialExtraction();
        } else {
            this.sequentialExtraction(pe,index);
        }
    },
    loadFailed : function(img,index,collect) {
        img.className = 'loadfailed';
        if (collect) {
            this.counterUpdate(); if (this.ICExecuting) this.sequentialExtraction();
        } else {
            this.sequentialExtraction(img.parentNode.parentNode,index);
        }
    },
    counterUpdate : function(loaded) {
        if (loaded) sf.id('loadedimg').innerText = parseInt(sf.id('loadedimg').innerText)+1;
        else sf.id('failedimg').innerText = parseInt(sf.id('failedimg').innerText)+1;
        if (sf.id('icremainder')) sf.id('icremainder').innerText = parseInt(sf.id('icremainder').innerText)-1;
    },
    collectionStart : function() {
        this.ICExecuting = ! this.ICExecuting;
        var es = document.getElementsByTagName('dd'), l = es.length, sequel = this.ICNextAnchor, ilink = 0;
        for (var i = this.ICNextRes; i < l; i++) {
            var as = es[i].getElementsByTagName('a'), asl = as.length;
            if (! as) {}
            else {for (var j = sequel; j < asl; j++) if (this.imgSuffix(as[j].href)) ilink++;}
            sequel = 0;
        }
        if (ilink > 0) {
            if (! this.ICExecuting) {
                sf.statusMessage('Interrupt',5000);
                setTimeout('if(!sfg.ICExecuting)sf.id("sfnavigator").removeChild(sf.id("icremainder"))',5000);
                return;
            }
            if (! sf.id('icremainder')) {
                var li = document.createElement('li'); li.id = 'icremainder'; li.innerText = ilink;
                sf.id('sfnavigator').insertBefore(li,sf.id('status').nextSibling);
            }
            if (! sf.id('sfgallery')) {
                var gallery = document.createElement('div'); gallery.id = 'sfgallery';
                gallery.innerHTML = '<div id="sfgalleryheader" onselectstart="return false;" ondragstart="return false;"><span id="gallerystatus"><span id="ilink">0</span> Image '+(ilink > 1 ? 'links' : 'link')+' - <span id="loadedimg">0</span> Loaded / <span id="failedimg">0</span> Failed</span><span id="gallerycontrol"><img src="'+SFR+'collectImages.png" onclick="sfg.collectionStart(true);" title="Collect Images" alt="Collect Images" /><img src="'+SFR+'slideShowStart.png" onclick="sfg.slideShow(\'Gallery\');" title="Slide show..." alt="Slide show" /><img id="gmbtn" src="'+SFR+'GalleryMode.png" onclick="sfg.GalleryMode();" title="Gallery Mode" alt="Gallery Mode" /><img src="'+SFR+'GalleryClose.png" onclick="sfg.GalleryClose();" title="Gallery Close" alt="Gallery Close" /></span></div>';
                document.body.appendChild(gallery);
                scrollTo(0,sf.id('sfgallery').offsetTop-(innerHeight-42));
            }
            sf.id('ilink').innerText = this.GalleryImgLength()+ilink;
            sf.statusMessage('Collecting images...');
            this.sequentialExtraction();
        } else {
            sf.attention('ic',l-this.ICNextRes); this.ICNextRes = l; this.ICExecuting = false;
            setTimeout('sf.statusMessage("")',3000);
            if (sf.id('icremainder')) setTimeout('sf.id("sfnavigator").removeChild(sf.id("icremainder"))',3000);
        }
    },
    sequentialExtraction : function(res,index) {
        var es = res ? res.getElementsByTagName('a') : document.getElementsByTagName('dd'), l = es.length, i;
        if (! res && ! this.ICExecuting && this.ICNextRes < l) return;
        var exclude = new RegExp('^(sevenfour:|applewebdata:)|youtube.com.watch.v=|video.google.com.videoplay.docid=|2ch.net.test.read.cgi|\.(zip|gz|sit|dmg|exe|jar|pdf|swf|mp3|mpe?g|avi|wmv)$','i');
        if (res) {
            for (i = index; i < l; i++) {
                var URI = es[i].href, str = es[i].innerText;
                if (this.imgSuffix(URI)) {this.load(es[i],URI,i+1,str); break;}
                else if (! exclude.test(URI)) {this.loadSS(es[i],URI,i+1); break;}
            }
        } else {
            IC: for (i = this.ICNextRes; i < l; i++) {
                var as = es[i].getElementsByTagName('a'), asl = as.length;
                if (! as) {
                } else {
                    for (var j = this.ICNextAnchor; j < asl; j++) {
                        var URI = as[j].href, pe = as[j].parentNode.parentNode; this.ICNextAnchor++;
                        if (this.imgSuffix(URI)) {
                            this.load(as[j],URI,j+1,pe.nodeName=='DIV'?pe.id:pe.parentNode.id,true); break IC;
                        }
                    }
                }
                this.ICNextAnchor = 0;
            }
        }
        if (! res && i == l) {
            sf.statusMessage('Complete',5000);
            this.ICNextRes = l; this.ICExecuting = false;
            sf.id('icremainder').innerText = '0';
            setTimeout('sf.id("sfnavigator").removeChild(sf.id("icremainder"))',5000);
        } else if (! res && this.ICExecuting) {
            sf.statusMessage('Collecting images...');
            this.ICNextRes = i;
        }
    },
    sizeAdjustment : function(img) {
        img.style.visibility = 'hidden';
        img.style.width = 'auto'; img.style.height = 'auto';
        if (sf.id('sfssoverlay')) {
            sf.id('ssimgwidth').innerText = img.width; sf.id('ssimgheight').innerText = img.height;
        }
        if (img.width > innerWidth) {img.style.width = (innerWidth-32)+'px';}
        if (img.height > (innerHeight-44)) {
            img.style.width = 'auto';
            img.style.height = (innerHeight-44)+'px';
        }
        var vertical_position = Math.round((innerHeight-img.height-25)/2);
        var center = Math.floor(img.width/2);
        img.style.marginTop = vertical_position > 10 ? vertical_position+'px' : '10px';
        sf.id('previmgarea').coords = '16,16,'+center+','+(img.height-16);
        sf.id('nextimgarea').coords = (center+1)+',16,'+(img.width-16)+','+(img.height-16);
        img.style.visibility = 'visible';
        Reflection.add(img,{height: 0.2, opacity: 0.5});
    },
    slideShow : function(direction) {
        if (! sf.id('sfssoverlay')) {
            SFSSImgs = [];
            var e = direction == 'Res' ? document.body : sf.id('sfgallery');
            var imgs = e.getElementsByTagName('img'), l = imgs.length;
            for (var i = 0; i < l; i++) {
                var permit = (/thumbnail|zoom|actual/.test(imgs[i].className) && imgs[i].style.visibility != 'hidden');
                if (direction == 'Res' && permit) {
                    var pe = imgs[i].className != 'actual' ? imgs[i].parentNode.parentNode.parentNode : imgs[i].parentNode.parentNode;
                    if (pe.className.indexOf('settled') == 0) SFSSImgs.push(imgs[i].src);
                } else if (permit) {
                    SFSSImgs.push(imgs[i].src);
                }
            }
            if (SFSSImgs.length == 0) {sf.attention('slideShow'); delete SFSSImgs; return;}
            document.body.style.overflow = 'hidden';
            SFSSImgs['currentIndex'] = 0;
            var sso = document.createElement('div'), ssimg = document.createElement('img');
            sso.id = 'sfssoverlay'; ssimg.id = 'slideshowimg';
            ssimg.setAttribute('usemap','#ssdirection'); ssimg.alt = 'SFSSImg';
            sso.innerHTML = '<div id="sfssnavi" onselectstart="return false;" ondragstart="return false;"><span id="ssinfo"><span id="sscurrentcount">1</span>/'+SFSSImgs.length+'&emsp;<span id="ssimgwidth">width</span> x <span id="ssimgheight">height</span></span><span id="sscontrol"><img id="previousimg" src="'+SFR+'previous.png" onclick="sfg.slideShow(\'previous\');" alt="prev" /><img id="nextimg" src="'+SFR+'next.png" onclick="sfg.slideShow(\'next\');" alt="next" /><img id="ssclose" src="'+SFR+'slideShowClose.png" onclick="sfg.slideShow(\'close\');" alt="close" /></span></div><map id="ssdirection" name="ssdirection"><area id="previmgarea" href="javascript:sfg.slideShow(\'previous\');" shape="rect" coords="" alt="Previous image" /><area id="nextimgarea" href="javascript:sfg.slideShow(\'next\');" shape="rect" coords="" alt="Next image" /></map>';
            document.body.appendChild(sso);
            sso.insertBefore(ssimg,sso.firstChild);
            ssimg.src = SFSSImgs[0];
            this.sizeAdjustment(ssimg);
            return;
        } else if (direction == 'close') {
            document.body.style.overflow = 'auto';
            document.body.removeChild(sf.id('sfssoverlay'));
            sf.correctRendering();
            delete SFSSImgs;
            return;
        }
        var img = sf.id('slideshowimg'), ssl = SFSSImgs.length, ci = SFSSImgs['currentIndex'];
        Reflection.remove(img);
        if (direction == 'next') {
            img.src = ci+1 == ssl ? SFSSImgs[0] : SFSSImgs[ci+1];
            SFSSImgs['currentIndex'] = ci+1 == ssl ? 0 : ci+1;
            sf.id('sscurrentcount').innerText = ci+1 == ssl ? 1 : ci+2;
        } else {
            img.src = ci == 0 ? SFSSImgs[ssl-1] : SFSSImgs[ci-1];
            SFSSImgs['currentIndex'] = ci == 0 ? ssl-1 : ci-1;
            sf.id('sscurrentcount').innerText = ci == 0 ? ssl : ci;
        }
        this.sizeAdjustment(img);
    },
    GalleryMode : function() {
        var dls = document.getElementsByTagName('dl'), dlsl = dls.length;
        var inactive = dls[0].style.display != 'none';
        sf.id('sfgalleryheader').style.zIndex = inactive ? 4 : 1;
        sf.toggle('sfinfobar'); sf.id('sfscroller').style.display = 'none';
        for (var i = 0; i < dlsl; i++) dls[i].style.display = inactive ? 'none' : 'block';
        sf.id('sfheader').style.display = inactive ? 'none' : 'block';
        sf.id('sfgallery').style.margin = inactive ? '0' : '39px 0 0';
        sf.id('sfgalleryheader').style.position = inactive ? 'fixed' : 'static';
        inactive ? sf.id('sfgalleryheader').style.width = '100%' : this.adjustGalleryHeader();
        sf.id('gmbtn').src = inactive ? SFR+'GalleryModeActive.png' : SFR+'GalleryMode.png';
        scrollTo(0,sf.id('sfgallery').offsetTop-39);
    },
    adjustGalleryHeader : function() {
        var imgs = sf.id('sfgallery').getElementsByTagName('img'), l = imgs.length, i, max = 0;
        for (i = 0; i < l; i++) if (imgs[i].className == 'actual' && imgs[i].width > max) max = imgs[i].width;
        sf.id('sfgalleryheader').style.width = max > innerWidth ? max+16+'px' : '100%';
    },
    GalleryClose : function() {
        if (sf.id('gmbtn').src.indexOf('Active') > 0) this.GalleryMode();
        document.body.removeChild(sf.id('sfgallery'));
        this.ICExecuting = false; this.ICNextRes = this.ICNextAnchor = 0; sf.statusMessage('');
        if (sf.id('icremainder')) sf.id('sfnavigator').removeChild(sf.id('icremainder'));
    },
    GalleryImgLength : function() {
        return sf.id('sfgallery') ? sf.id('sfgallery').getElementsByTagName('a').length : 0;
    },
    resize : function(img,img_parent) {
        var e = img_parent.className == 'reflexunit' ? img_parent : img;
        if (img.style.visibility == 'hidden' || e.nextSibling.className != 'imgtoggle') return;
        var ic = e.parentNode;
        img.className = img.className == 'thumbnail' ? 'zoom' : img.className == 'zoom' ? 'actual' : 'thumbnail';
        if (ic.parentNode.nodeName == 'DD') this.centeringBtn(e.nextSibling,img);
        else ic.style.margin = img.className != 'thumbnail' ? '50px 8px 5px' :
             ic.className.indexOf('right') != -1 ? '50px 0 5px 32%' : '50px 32% 5px 0';
        img.className == 'thumbnail' ? Reflection.add(img,{height: 0.2, opacity: 0.7}) :
        img.className == 'zoom' ? Reflection.add(img,{height: 0.07, opacity: 0.7}) : Reflection.remove(img);
        if (img.className != 'actual') scrollTo(0,img.offsetTop-25);
        else sf.statusMessage('Actual size: '+img.width+' x '+img.height,8000);
        if (ic.parentNode.id == 'sfgallery' && sf.id('gmbtn').src.indexOf('Active') == -1) this.adjustGalleryHeader();
    },
    toggle : function(btn) {
        var e = btn.parentNode.firstChild, img = e.className == 'reflexunit' ? e.firstChild : e;
        var visible = img.style.visibility != 'hidden';
        img.style.visibility = visible ? 'hidden' : 'visible';
        if (e.className == 'reflexunit') img.nextSibling.style.visibility = visible ? 'hidden' : 'visible';
        btn.src = SFR+(visible ? 'show' : 'hide')+'Img.png';
    },
    display : function(zap) {
        var imgs = document.images, l = imgs.length, vis = zap ? 'hidden' : 'visible';
        var btn_src = SFR+(zap ? 'show' : 'hide')+'Img.png';
        for (var i = 0; i < l; i++) {
            var img = imgs[i];
            if (img.src.indexOf('http:') != 0) {
            } else if (img.className != 'loadfailed') {
                if (zap && (img.className == 'zoom' || img.className == 'actual')) {
                    img.className = 'thumbnail'; Reflection.add(img,{height: 0.2, opacity: 0.7});
                    if (sf.id('sfgallery')) sf.id('sfgalleryheader').style.width = '100%';
                }
               if (img.className != 'thumbnail') {
                    img.style.visibility = vis;
                } else {
                    var ref_unit = img.parentNode, ic = ref_unit.parentNode;
                    img.style.visibility = img.nextSibling.style.visibility = vis;
                    ref_unit.nextSibling.src = btn_src;
                    if (ic.parentNode.nodeName == 'DD') this.centeringBtn(ref_unit.nextSibling,img);
                    else ic.style.margin = ic.className.indexOf('right') != -1 ? '50px 0 5px 32%' : '50px 32% 5px 0';
                }
            }
        }
    },
    centeringBtn : function(btn,img) {
        btn.style.marginLeft = img.width > window.innerWidth ?
            Math.floor((window.innerWidth-7)/2)+'px' : Math.floor((img.width-7)/2)+'px';
    }
};

/* Utility */
var sf = {
    id : function(id) {
        return document.getElementById(id+'');
    },
    evTarget : function(evt) {
        return SFIsTiger ? evt : evt.nodeName == '#text' ? evt.parentNode : evt;
    },
    element : function(element,tag,value) {
        if (typeof(element) != 'object') element = sf.id(element);
        element = element.getElementsByTagName(tag)[0].item(tag != 'id' ? 0 : 1);
        if (tag != 'id') {
            return value ? element.innerText : element;
        } else {
            var id = element.innerText.substr(3);
            return value ? id : id != '???' ? element.item(1) : element;
        }
    },
    latestRes : function(actual) {
        var dts = document.getElementsByTagName('dt'), l = dts.length-1;
        if (dts[l].parentNode.id > 1000) l -= 1;
        if (actual) return dts[l].parentNode;
        for (var i = l; i >= 0 ; i--) {
            var e = dts[i].parentNode; if (e.style.display != 'none') return e;
        }
        return dts[l].parentNode;
    },
    toggle : function(id,sw) {
        var es = sf.id(id).style;
        if (! es.display) es.display = id == 'sfnavigator' || id == 'sfinfobar' ? 'block' : 'none';
        switch (es.display) {
            case 'none': if (id == 'sfscroller') es.top = Math.round((innerHeight-169)/2)+'px';
                if (id == 'sfrestrictor') es.left = Math.round((innerWidth-169)/2)+'px';
                es.display = 'block'; if (id == 'sfscroller') document.jump.directscroller.focus();
                break;
            case 'block': if (id == 'sfscroller') document.jump.directscroller.blur();
                es.display = 'none'; if (id == 'sfnavigator' && SFISCache) sfi.fade();
                break;
        }
    },
    statusMessage : function(str,timeout) {
        clearTimeout(SFMessageClear); SFMessageClear = 0;
        sf.id('status').innerText = str;
        if (timeout) SFMessageClear = setTimeout('sf.id("status").innerText=""',timeout);
    },
    displayTheResult : function(result,act,time) {
        if (result == 0) {
            this.statusMessage('Not found',7000);
        } else {
            this.statusMessage(act == 'zap' ? result+' Res restricted' :
                               act == 'zapThisRes' ? result+' Res restricted (Maybe not unique ID)' :
                               time ? result+' Found / '+time : result+' Found',
                               act == 'iSearch' && ! sf.id('pumode').checked ? false : 7000);
            if (act.indexOf('zap') == 0) this.attention('zap',result);
        }
    },
    attention : function(act,count) {
        if (! sf.id('sfattention')) {
            var div = document.createElement('div'); div.id = 'sfattention';
            div.style.left = Math.round((document.width-365)/2)+'px';
            document.body.appendChild(div);
        } else {
            clearTimeout(SFRemoveBezel);
        }
        switch (act) {
            case 'zap': act = 'Res Filter ∷ '+count+' 件のレスがフィルタリングされました'; this.correctRendering(); break;
            case 'ic': act = 'Image Collect ∷ '+(count==0?'新しいリンクはありません':'画像へのリンクはありません'); break;
            case 'slideShow': act = 'Slide Show ∷ スライドショー可能な画像はありません'; break;
            case 'AccessDenied': act = 'Access Denied ∷ Please reset the restrictor or search result'; break;
        }
        sf.id('sfattention').innerText = act;
        SFRemoveBezel = setTimeout('document.body.removeChild(sf.id("sfattention"))',5000);
    },
    gradationString : function(element,r,g,b,v) {
        var str = element.innerText, l = str.length, gs = '', s = Math.floor(v/l), c = Math.floor(l/2);
        var sr = r, sg = g, sb = b;
        for (var i = 0; i < l; i++) {
            var color = 'rgb('+r+','+g+','+b+')'; gs += str.charAt(i).fontcolor(color);
            if (i < c) {
                r = r+s < 255 ? r+s : 255; g = g+s < 255 ? g+s : 255; b = b+s < 255 ? b+s : 255;
            } else {
                r = r-s > sr ? r-s : sr; g = g-s > sg ? g-s : sg; b = b-s > sb ? b-s : sb;
            }
        }
        element.innerHTML = gs;
    },
    informationChange : function(info) {
        var str = info.innerText;
        info.innerText = str == document.title ? SFThreadURI :
                         str == SFThreadURI ? this.elapsedTime(1) :
                         str.indexOf('最初') == 0 ? this.elapsedTime(this.latestRes().id) : document.title;
    },
    rangeChanger : function(update) {
        var rc = sf.id('rangechanger');
        if (rc && ! update) {rc.parentNode.removeChild(rc); return;}
        var l = parseInt(this.latestRes(true).id);
        if (l > 50) {
            if (! rc) {rc = document.createElement('span'); rc.id = 'rangechanger';}
            var str = '<span onclick="sf.switchLoadfactor(';
            rc.innerHTML = ' 最新 ▶'+str+'51)">50</span>';
            for (var i = 100; i < l; i += 100) if (l > i) rc.innerHTML += str+(i+1)+')">'+i+'</span>';
            if (l > document.getElementsByTagName('dt').length && ! SFAbbreviated)
                rc.innerHTML += str+'\'Full\')">All</span>';
            sf.id('loadfactor').parentNode.insertBefore(rc,sf.id('loadfactor'));
        }
    },
    switchLoadfactor : function(lf) {
        location.replace(lf == 'Full' ? SFThreadURI : lf ? SFThreadURI+'l'+lf :
                         SFAbbreviated ? SFThreadURI : SFThreadURI+'/NEW');
    },
    setSnapBackAnchor : function(element) {
        if (element.id) {element.removeAttribute('id');}
        else {if (sf.id('bookmark')) sf.id('bookmark').removeAttribute('id'); element.id = 'bookmark';}
    },
    correctRendering : function() {
        var top = pageYOffset == 0, bottom = pageYOffset == (document.height-innerHeight);
        scrollBy(0,top ? 1 : -1); scrollBy(0,top ? -1 : bottom ? 25 : 1);
    },
    autoScroll : function(speed) {
        clearInterval(SFScrolling);
        switch (speed) {
            case 'slow':
                SFScrolling = setInterval(function() {
                    pageYOffset < (document.height-innerHeight) ? scrollBy(0,1) : sf.autoScroll('stop');
                },100); break;
            case 'fast':
                SFScrolling = setInterval(function() {
                    pageYOffset < (document.height-innerHeight) ? scrollBy(0,1) : sf.autoScroll('stop');
                },50); break;
            default: SFScrolling = 0; break;
        }
    },
    loadTimer : function(stf) {
        var elapsed_time = (new Date().getTime()-(stf ? stf.getTime() : SFStart.getTime()))/1000+' sec.';
        if (stf) {
            return elapsed_time;
        } else {
            this.statusMessage(document.readyState+' / '+elapsed_time,5000);
            sf.id('loadtime').innerText = elapsed_time; SFStart = 0;
        }
    },
    parseTime : function(res_number) {
        var date_str = sf.element(res_number,'date',true);
        var day = new RegExp('[0-9]+\/[0-9]+\/[0-9]+'), time = new RegExp(' [0-9]+:[0-9]+:[0-9]+');
        date_str = date_str.match(day)+date_str.match(time)+' GMT+0900';
        if (! SFIsTiger) {
            var ds = date_str.match(/([0-9]{4}).([0-9]{2}).([0-9]{2}) (.+) /);
            var m = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
            date_str = m[parseInt(ds[2])-1]+' '+ds[3]+' '+ds[1]+' '+ds[4]+' GMT+0900';
        }
        return Date.parse(date_str);
    },
    elapsedTime : function(res_number) {
        var reference = this.parseTime(res_number), current = Date.parse(new Date());
        if (! reference || this.latestRes().id != this.latestRes(true).id) this.attention('AccessDenied');
        var elapsed = new Date((current-reference)-(9*60*60*1000));
        var year = elapsed.getFullYear()-1970, month = elapsed.getMonth(), date = elapsed.getDate()-1;
        var hour = elapsed.getHours(), min = elapsed.getMinutes(), sec = elapsed.getSeconds();
        var str = res_number == 1 ? '最初のレスから ' : '最新のレスから ';
        if (year > 0) str += year+'年 ';
        if (month > 0) str += month+'ヶ月 ';
        if (date > 0) str += date+'日 ';
        if (hour > 0) str += hour+'時間 ';
        if (min > 0) str += min+'分 ';
        if (sec > 0) str += sec+'秒 ';
        return str += '経過';
    },
    velocity : function() {
        var nor = parseInt(this.latestRes().id), first = this.parseTime(1), latest = this.parseTime(nor);
        var elapsed = new Date((latest-first)).getTime()/1000/60/60;
        return (nor/elapsed).toString().match(/[0-9]+[^0-9]?[0-9]{0,3}/);
    },
    GetInfo : function() {
        if (sf.id('sfinspector')) {document.body.removeChild(sf.id('sfinspector')); return;}
        var ins = document.createElement('div'); ins.id = 'sfinspector';
        ins.style.left = Math.floor((window.innerWidth-412)/2)+'px';
        try {var sfv = 'SevenFour '+sfSystem.version();} catch (e) {sfv = 'SF '+SFSkinName+' はこのバージョンの SevenFour をサポートしていません…';}
        ins.innerHTML = '<img class="remove" src="'+SFR+'hideImg.png" alt="remove" /><span>Thread  Information</span><hr /><br />'+document.title+'<br />'+SFThreadURI+'<br /><br /><span>Parent Directory : </span>'+sf.id('parentdirectory').innerText.toLowerCase()+'<br /><span>Board URI : </span>'+sf.id('parentdirectory').href+'<br /><br />'+this.elapsedTime(1)+'<br />'+this.elapsedTime(sf.latestRes().id)+'<br /><br /><span>1 時間あたりのレス数 : </span>'+sf.velocity()+'<br /><br /><br /><span>Browser Information</span><hr /><br />'+sfv+'<br /><br /><span>Platform : </span>'+navigator.platform+'<br /><span>WebKit version : </span>'+navigator.appVersion.match(/AppleWebKit[^ ]+/i)+'<br /><br /><span>Skin : </span>SF The Oort Cloud v1.3RC1 r070716';
        document.body.appendChild(ins);
    },
    changeTheAppearance : function() {
        try {
            sfSystem.setBoardListBGColor(231,237,246);//Aqua
            //sfSystem.setBoardListBGColor(209,215,226);//Graphite
            //sfSystem.setBoardListBGColor(230,230,230);//Platinum
            sfSystem.setBoardListFontColor(8,8,8);
            sfSystem.restThreadListAppearance();
        } catch (e) {alert(e);}
    }
};

/* Event handling */
window.onload = function() {
    var dts = document.getElementsByTagName('dt'), l = dts.length;
    document.URL.indexOf('apple') == 0 ? sfevt.onPopup(dts[0],l) : sfevt.onLoad(dts,l);
};
document.onkeydown = function() {
    if (event.metaKey) return;//⌘
    if (event.ctrlKey) {
        switch (event.keyCode) {
            case 65: sf.toggle('sfnavigator'); break;//a
            case 82: sf.toggle('sfrestrictor'); break;//r
            case 74: sf.toggle('sfscroller'); break;//j
            case 78: sevenfour.scrollToNew(); break;//n
            case 66: sevenfour.scrollToMessage('b'); break;//b
            case 70: sfi.fade(); break;//f
            case 83: sfi.quick('search',SFSelectedText); break;//s
            case 72: event.shiftKey?sfi.reset(true):sfi.quick('highlight',SFSelectedText); break;//h
            case 71: event.shiftKey?sfi.webSearch('SearchMash'):event.altKey?sfi.webSearch('Clusty'):sfi.webSearch('Google'); break;//g
            case 84: sfi.webSearch('Translate'); break;//t
            case 69: sfi.webSearch('Wikipedia'); break;//e
            case 77: sfi.webSearch('iTS'); break;//m
            case 73: sfg.collectionStart(); break;//i
            case 90: sfg.slideShow('previous'); break;//z
            case 88: sfg.slideShow('next'); break;//x
            case 222: sfi.webSearch('Google:2ch.net'); break;//control+shift+2
            default: return;
        }
        event.returnValue = false;
    }
    if (event.altKey) {
        switch (event.keyCode) {
            case 82: event.shiftKey?sfi.modeChange('remode'):sfi.modeChange('rsmode'); break;//r
            case 78: sfi.modeChange('nsmode'); break;//n
            case 87: sfi.modeChange('wsmode'); break;//w
            case 85: sfi.modeChange('urimode'); break;//u
            case 79: sfi.modeChange('cycleopt',sf.id('pumode').checked,sf.id('rfmode').checked); break;//o
            default: return;
        }
        event.returnValue = false;
    }
    var e = document.isearch.query;
    if (event.target == e && e.value && event.keyCode == 13) sfi.iSearch(e.value);//return
};
document.onmousedown = function() {
    var e = sf.evTarget(event.target);
    if (e.id != 'autoscroll') sf.autoScroll('stop');
};
document.onclick = function() {
    var e = sf.evTarget(event.target);
    switch (e.id) {
        case 'sfinfobar': sf.informationChange(sf.id('information')); break;
        case 'rangechanger': sf.rangeChanger(); break;
    }
    switch (e.className) {
        case 'imgtoggle': sfg.toggle(e); break;
        case 'imgopener': location.replace(e.parentNode.getElementsByTagName('img')[0].src); break;
        case 'remove': document.body.removeChild(e.parentNode); break;
        case 'zapsameid': sfevt.zapSameID(e.parentNode.parentNode); break;
    }
    switch (e.nodeName) {
        case 'IMG': sfg.resize(e,e.parentNode); break;
        case 'DD': sfevt.extractionSequence(e); break;
        case 'SECONDSECTION': sf.setSnapBackAnchor(e);
    }
};
document.oncopy = function() {
    sfi.setValue(SFSelectedText);
};
